#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "Fish_JuKunFuHuaJiFenCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<Fish_JuKunFuHuaJiFenCFG> Fish_JuKunFuHuaJiFenCFG::msSingleton(nullptr);

int Fish_JuKunFuHuaJiFenCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_JuKunFuHuaJiFenCFGData* Fish_JuKunFuHuaJiFenCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, Fish_JuKunFuHuaJiFenCFGData>& Fish_JuKunFuHuaJiFenCFG::GetMapData()
{
	return mMapData;
}

void Fish_JuKunFuHuaJiFenCFG::Reload()
{
	mMapData.clear();
	Load();
}

void Fish_JuKunFuHuaJiFenCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_JuKunFuHuaJiFenCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mIntegralLower = element->IntAttribute("IntegralLower");
		data.mIntegralUpper = element->IntAttribute("IntegralUpper");
		data.mWeight = element->IntAttribute("Weight");
		{
			const char* BonusPoints = element->Attribute("BonusPoints");
			std::vector<std::string> vecBonusPoints;
			boost::split(vecBonusPoints, BonusPoints, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecBonusPoints.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecBonusPoints[i].c_str(), &temp))
				{
					data.mBonusPoints.push_back(temp);
				}
			}
		}
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void Fish_JuKunFuHuaJiFenCFG::Load()
{
	Load("../Config/Fish_JuKunFuHuaJiFenCFG.xml");
}

Fish_JuKunFuHuaJiFenCFG* Fish_JuKunFuHuaJiFenCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_JuKunFuHuaJiFenCFG());
	}
	return msSingleton.get();
}
